#include <ButtonConstants.au3>
#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
#include <String.au3>

Opt("TrayMenuMode", 1)
opt("TrayAutoPause",0)
Opt("WinWaitDelay",200)
Opt("WinTitleMatchMode",2)
Opt("WinDetectHiddenText",1)
opt("WinSearchChildren",1)
Opt("MouseCoordMode",0)

global $serveur=IniRead(@ScriptDir & "\pop.ini", "login", "serveur", "NotFound")
global $delai=IniRead(@ScriptDir & "\pop.ini", "login", "delai", "NotFound")
global $webmail=IniRead(@ScriptDir & "\pop.ini", "login", "webmail", "NotFound")
global $last_number_of_mail = 0

;##########################################################################################
;##################################### Pop Mail V1.0- Marc P. @ petitmarco@yahoo.com ######

;##############################  Pop.ini ###############################################

pop_ini() ; initialisation des parametre de connexion au Pop3

;##################################### Cration du menu ######################

$mail = _notify()
$m_navigateur = TrayCreateItem("Ouvrir Pop Mail V1.0")
$m_connect = TrayCreateItem("Accs Webmail Zimbra")
TrayCreateItem("")
$m_mail= TrayCreateItem($mail & " Message(s)")
TrayCreateItem("")
$m_open1 = TrayCreateItem("Re-Initialiser pop.ini")
$m_open2 = TrayCreateItem("Ouvrir le pop.ini")
TrayCreateItem("")
$m_exit = TrayCreateItem("Quitter")
$m_info = TrayCreateItem("Info")

TraySetState()
TraySetClick(9)
GUISetState(@SW_SHOW)
;~ TraySetIcon(@ScriptDir & "\ico2.ico")

$debut = TimerInit()


While 1
	$msg1 = TrayGetMsg()
	$diff=TimerDiff($debut)
	if $diff>$delai then ;15 minutes = 60000*15
		$mail=_notify()
		TrayItemSetText($m_mail, $mail & " Message(s)")
		$debut = TimerInit()
	EndIf
	Select
		Case $msg1 = 0
			ContinueLoop
		Case $msg1 = $m_mail	
			TrayItemSetText($m_mail, _notify() & " Message(s)")
		Case $msg1 = $m_navigateur
			run(@ScriptDir & "\pop_navigateur.exe")
		Case $msg1 = $m_connect
			start()
		case $msg1 = $m_open1
			initialise()
		case $msg1 = $m_open2
			ShellExecute(@ScriptDir & "\pop.ini")
		Case $msg1 = $m_exit
			exit
		Case $msg1=$m_info
			_info()
	EndSelect
WEnd

func start()
	
	global $webmail=IniRead(@ScriptDir & "\pop.ini", "login", "webmail", "NotFound")
	if $webmail="zimbra.free.fr"  Then
		#include "_html.au3" ;script gnre le fichier HTML complit avec les lments du INI crypt
						; ce fichier contient du Javascript pour soumettre directement les info du compte Pop3 au serveur
	
		ShellExecute(@ScriptDir & "\pop.htm")
		sleep(2000)
		if fileExists(@ScriptDir & "\pop.htm") then filedelete(@ScriptDir & "\pop.htm")
	Else
		msgbox(64,"Pop Mail","Le navigateur Pop Mail fonctionne seulement avec Zimbra de Free")
	endif	
		
EndFunc

func initialise()
	$continue=msgbox(1,"Pop Mail","R-iniatilsation pop.ini " & @lf & @lf & _
					"Etes vous sur de vouloire poursuivre ?, cette opration effacera le fichier pop.ini existant")
	if $continue=1 Then
		if fileExists(@ScriptDir & "\pop.ini") then filedelete(@ScriptDir & "\pop.ini")
		pop_ini()
	endif
EndFunc

func pop_ini()
	#include "_ini.au3" ; script pour lire des donnes cryptes du Ini sur le compte Pop3
endfunc

Func _notify()
    SetError(0)     
    TCPStartup ()
	$a = _pop3compt (_Pop3start ($serveur, 110, $id, $pass))
	
	select 
		
		case $a>=0
			If $a=$last_number_of_mail Then msgbox(64,"Mail Notificateur",  $a & " Messages dans la Bote de rception",5)
			If $a > $last_number_of_mail Then
				;nouveaux mails
				msgbox(64,"Mail Notificateur",  $a - $last_number_of_mail & " Nouveau(x) Message(s) dans la Bote de rception",5)
				$last_number_of_mail = $a ; maj de la globale
			EndIf
			
			If $a < $last_number_of_mail and $a > 0 Then
				msgbox(64,"Mail Notificateur",  $a & " Messages dans la Bote de rception",5)
				;donc mise  jour de la variable tmoin:
				$last_number_of_mail = $a
			endif
			Return $a
			
		Case $a= -1 
			SetError(1)
			msgbox (64,"Mail Notificateur", "Connexion au serveur chou",10)
			return "?" ; pas de connexion possible      ; <<<======== je mettrai un autre type de retours, car ici la fonction retourne un coups
			;du number, un coups de la string ...
		Case else
			SetError(2)
			msgbox (64,"Mail Notificateur", "Paramtre de retours inconnu",10)
			Return "?"
    EndSelect
    TCPCloseSocket ($pop3_socket)
    TCPShutDown ()
EndFunc

Func _Pop3start ($sServer, $iPort, $sUser, $sPass)
	;connect
	$sock = TCPConnect (TCPNameToIP ($sServer), $iPort); 
;~ 	 	ou avec L'ip serveur -> 
;~	 	$sock = TCPConnect ($sServer, $iPort)
	If @error Then Return SetError (3, @ScriptLineNumber, -1)
	$iTime = TimerInit ()
	Do
		If TimerDiff ($iTime) > 15000 Then Return SetError (1, @ScriptLineNumber, -1)
		$sRecv = TCPRecv($sock, 32)
	Until StringLeft($sRecv, 3) = "+OK"
			
	;auth
	TCPSend ($sock, "USER "&$sUser&@CRLF)
	$iTime = TimerInit ()
	Do
		If TimerDiff ($iTime) > 15000 Then Return SetError (1, @ScriptLineNumber, -1)
		$sRecv = TCPRecv($sock, 32)
		Sleep (10)
		If StringLeft($sRecv, 4) = "-ERR" Then Return SetError (2, @ScriptLineNumber, -1)
	Until StringLeft($sRecv, 3) = "+OK"
	TCPSend ($sock, "PASS "&$sPass&@CRLF)
	Do
	If TimerDiff ($iTime) > 15000 Then Return SetError (1, @ScriptLineNumber, -1)
	$sRecv = TCPRecv($sock, 32)
	Sleep(10)
	If StringLeft($sRecv, 4) = "-ERR" Then Return SetError (2, @ScriptLineNumber, -1)
	Until StringLeft($sRecv, 3) = "+OK"
	Return $sock
EndFunc

Func _pop3compt ($sock)
    TCPSend ($sock, "STAT"&@CRLF)
    $iTime = TimerInit ()
    Do
        If TimerDiff ($iTime) > 15000 Then Return SetError (1, @ScriptLineNumber, -1)
        $sRecv = TCPRecv($sock, 32)
        Sleep(10)
    Until StringLeft($sRecv, 3) = "+OK"
           
    $aSplit = StringSplit ($sRecv, " ")
    If $aSplit[0] < 3 Then Return SetError (2, @ScriptLineNumber, -1)
    Return $aSplit[2]
EndFunc

Func _info()
		$pos = MouseGetPos()
	$y=@DesktopHeight
	$x=@DesktopWidth
	if $pos[0]>($x-360) then $pos[0]=($x-310) ;si left x> largeur ecran - (taille fenetre+10)
	if $pos[1]>($y-250) then $pos[1]=($y-250) ;si right y > hauteur ecran - (taille fenetre+50)	
	$WinMain=GUICreate('', 300, 150, $pos[0], $pos[1],$WS_POPUPWINDOW,$WS_EX_STATICEDGE)
	
	GUISetBkColor(0xffFFFF)
		
	$gui1=GUICtrlCreateLabel('Pop Mail V1.0 - 2008',5,10,300)
	GUICtrlSetFont($gui1,15)
	GUICtrlSetResizing ($gui1, $GUI_DOCKHCENTER)
	$gui2=GUICtrlCreateLabel('Autheur : Marc P.',5,40,500)	
	GUICtrlSetFont($gui2,12,800)
	$gui4=GUICtrlCreateLabel('Email : [petitmarco@yahoo.com]',5,80,500)
	
	$gui3=GUICtrlCreateLabel('2008 - Version ZIMBRA Free',5,100)	
	GUICtrlSetResizing ($gui3, $GUI_DOCKHCENTER)
	$Boutton2 = GUICtrlCreateButton('Ok', 100, 120, 100, 20)
	
	GUISetState()
		
	While 1
			Switch GUIGetMsg()
			case $Boutton2
					GUIDelete()
					exitloop
			Case $GUI_EVENT_CLOSE
					GUIDelete()
					exitloop
;~ 				
			EndSwitch
		WEnd 
	GUIDelete()
EndFunc